clear;clc;close all
clear

[~,~,data_VAR] = xlsread('dataVAR_forweb.xlsx');% [date rpix ip 5y 10y CS(6) LIBOR(7) PR(8) ER(9) 
                                             % T-Bill MS VIX FTSE ]


  
y=[data_VAR(:,4) data_VAR(:,2) data_VAR(:,3) data_VAR(:,11) data_VAR(:,9)  data_VAR(:,6)];

    
titles=y(1,:);

y=cell2mat(y(2:end,:));


p = 12;
horizon = 50;
[T,k] = size(y);
Y1 = y(p+1:end,:);
X  = zeros(T-p,p*k);

%% VAR(p) estimation

for i=1:p;
  X(:,k*i-k+1:k*i)=y(p+1-i:end-i,:);
end
cons   = ones(T-p,1);
X1     = [cons X];
beta   = (X1'*X1)\(X1'*Y1);
mu_hat = Y1-X1*beta;

%% downloading instruments


instr=xlsread('surprises_forweb.xlsx');
instr=instr(31:end,:);

inst=instr(:,3)+instr(:,4);

[Tinst,kist]= size(inst);

%% 2-nd stage
s_hat=instrumF(inst,mu_hat,T, p,k);

%% Impulse response functions
IRF= irfinst(X1,Y1,horizon,T,k,p,s_hat);

%% Bootstrapping Confidence bands (Wild bootstrap as in GK)

hor=1000;
y_bb=zeros(T,k);
y_bb(1:p,:)=y(1:p,:);
irfb = zeros(k,horizon,hor);
%mu_hat = detrend(mu_hat,'constant'); %(deleting means from residuals)



 
for j=1:hor

    %ran=randn(T-p,1); %standard normal instead of Rademacher
    ran = 1-2*(rand(T-p,1)>0.5);
    v=(ran*ones(1,k));
    mu_hat_b=mu_hat.*v;
    for i=p+1:T
        y_bb(i,:)=beta(1,:)+ y_bb(i-1,:)*beta(2:k+1,:)+ mu_hat_b(i-p,:)...
                          + y_bb(i-2,:)*beta(k+2:2*k+1,:)...
                          + y_bb(i-3,:)*beta(2*k+2:3*k+1,:)...
                          + y_bb(i-4,:)*beta(3*k+2:4*k+1,:)...
                          + y_bb(i-5,:)*beta(4*k+2:5*k+1,:)...
                          + y_bb(i-6,:)*beta(5*k+2:6*k+1,:)...
                          + y_bb(i-7,:)*beta(6*k+2:7*k+1,:)...
                          + y_bb(i-8,:)*beta(7*k+2:8*k+1,:)...
                          + y_bb(i-9,:)*beta(8*k+2:9*k+1,:)...
                          + y_bb(i-10,:)*beta(9*k+2:10*k+1,:)...
                          + y_bb(i-11,:)*beta(10*k+2:11*k+1,:)...
                          + y_bb(i-12,:)*beta(11*k+2:12*k+1,:);  
    
    end
     

    for ii=1:p;
        X_bb(:,k*ii-k+1:k*ii)=y_bb(p+1-ii:end-ii,:);
    end
    
    X1_b=[ones(length(y_bb)-p,1), X_bb];
    Y1_b = y_bb(p+1:end,:);
    beta_b   = (X1_b'*X1_b)\(X1_b'*Y1_b);
    mu_hat_bb = Y1_b-X1_b*beta_b;

    %randomizing instruments
    ran_ins=ran(T-p-Tinst+1:T-p,:);
    ran_ins=ran_ins*ones(kist,1)';
    instrb=inst.*ran_ins;
    s_hat_b=instrum(instrb,mu_hat_bb,T, p,k);  
    irfb(:,:,j)=irfinst(X1_b,Y1_b,horizon,length(y),k,p,s_hat_b);

end

%Quantile confidence bands

upboundq=zeros(k,horizon-1);
lwboundq=zeros(k,horizon-1);

for i2=1:k
    for i3=1:horizon-1
        upboundq(i2,i3) = quantile(irfb(i2,i3,:),.95);
        lwboundq(i2,i3) = quantile(irfb(i2,i3,:),.05);
    end
end

 

%% Plotting IRS's
get(gca,'fontname')  % shows you what you are using.
set(gca,'fontname','times')  % Set it to times

    figure(1)

    subplot(3,2,1);
    plot(upboundq(1,:)','--');hold on
    plot(lwboundq(1,:)','--');hold on
    plot(IRF(1,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    ylim([-0.3 0.5])
    xlim([1 horizon-1])
    ylabel('%', 'FontName','Times New Roman');

    title(titles(1))
    

    subplot(3,2,2);
    plot(upboundq(2,:)','--');hold on
    plot(lwboundq(2,:)','--');hold on
    plot(IRF(2,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    ylim([-0.3 0.6])
    xlim([1 horizon-1])
    ylabel('%');
    
    title(titles(2))

    subplot(3,2,3);
    plot(upboundq(3,:)','--');hold on
    plot(lwboundq(3,:)','--');hold on
    plot(IRF(3,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    ylim([-0.7 0.6])
    xlim([1 horizon-1])
    ylabel('%');
    
    title(titles(3))

    subplot(3,2,4);
    plot(upboundq(4,:)','--');hold on
    plot(lwboundq(4,:)','--');hold on
    plot(IRF(4,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    xlim([1 horizon-1])
    ylabel('%');
    title(titles(4))

        
    subplot(3,2,5);
    plot(upboundq(5,:)','--');hold on
    plot(lwboundq(5,:)','--');hold on
    plot(IRF(5,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    xlim([1 horizon-1])
    ylabel('%');
    
    title(titles(5))
    
    
    subplot(3,2,6);
    plot(upboundq(6,:)','--');hold on
    plot(lwboundq(6,:)','--');hold on
    plot(IRF(6,1:end-1)','b','LineWidth',2);hold on
    plot(zeros(1,horizon+9),'-.b'),hold off
    xlim([1 horizon-1])
    ylabel('%');
   
    title(titles(6))
    



